package org.jeecg.modules.device.controller;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.constant.CommonConstant;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.device.entity.BuMaintenanceHistory;
import org.jeecg.modules.device.entity.BuMaintenanceStatus;
import org.jeecg.modules.device.service.IBuMaintenanceHistoryService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.device.service.IBuMaintenanceStatusService;
import org.jeecg.modules.system.entity.SysAnnouncementSend;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 维保历史表
 * @Author: jeecg-boot
 * @Date:   2024-06-11
 * @Version: V1.0
 */
@Api(tags="维保历史表")
@RestController
@RequestMapping("/device/buMaintenanceHistory")
@Slf4j
public class BuMaintenanceHistoryController extends JeecgController<BuMaintenanceHistory, IBuMaintenanceHistoryService> {
	@Autowired
	private IBuMaintenanceHistoryService buMaintenanceHistoryService;
	 @Autowired
	 private IBuMaintenanceStatusService buMaintenanceStatusService;

	/**
	 * 分页列表查询
	 *
	 * @param buMaintenanceHistory
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "维保历史表-分页列表查询")
	@ApiOperation(value="维保历史表-分页列表查询", notes="维保历史表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuMaintenanceHistory>> queryPageList(BuMaintenanceHistory buMaintenanceHistory,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuMaintenanceHistory> queryWrapper = QueryGenerator.initQueryWrapper(buMaintenanceHistory, req.getParameterMap());
		Page<BuMaintenanceHistory> page = new Page<BuMaintenanceHistory>(pageNo, pageSize);
		IPage<BuMaintenanceHistory> pageList = buMaintenanceHistoryService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	@GetMapping(value = "/listByUser")
	public Result<?> listByUser(){
		JSONObject obj = new JSONObject();
		QueryWrapper<BuMaintenanceHistory> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("status",0);
		List<BuMaintenanceHistory> list = buMaintenanceHistoryService.list(queryWrapper);
		obj.put("record",list);
		obj.put("count",list.size());
		return Result.OK(obj);
	}

	@PutMapping(value = "/editMaintenanceSend")
	public Result<?> editMaintenanceSend(@RequestBody JSONObject json){
		Result<BuMaintenanceHistory> result = new Result<BuMaintenanceHistory>();
		String anntId = json.getString("anntId");
		BuMaintenanceHistory buMaintenanceHistory = buMaintenanceHistoryService.getById(anntId);
		buMaintenanceHistory.setStatus(1);
		buMaintenanceHistoryService.updateById(buMaintenanceHistory);
		result.setSuccess(true);
		return result;
	}


	/**
	 *   添加
	 *
	 * @param buMaintenanceHistory
	 * @return
	 */
	@AutoLog(value = "维保历史表-添加")
	@ApiOperation(value="维保历史表-添加", notes="维保历史表-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_maintenance_history:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuMaintenanceHistory buMaintenanceHistory) {
		buMaintenanceHistoryService.save(buMaintenanceHistory);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param buMaintenanceHistory
	 * @return
	 */
	@AutoLog(value = "维保历史表-编辑")
	@ApiOperation(value="维保历史表-编辑", notes="维保历史表-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_maintenance_history:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuMaintenanceHistory buMaintenanceHistory) {
		buMaintenanceHistory.setStatus(2);
		QueryWrapper<BuMaintenanceStatus> queryWrapper = new QueryWrapper<>();
		queryWrapper.eq("device_id",buMaintenanceHistory.getDeviceId());
		BuMaintenanceStatus buMaintenanceStatus = buMaintenanceStatusService.getOne(queryWrapper);
		buMaintenanceStatus.setUpdateTime(new Date());
		buMaintenanceStatusService.updateById(buMaintenanceStatus);
		buMaintenanceHistoryService.updateById(buMaintenanceHistory);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "维保历史表-通过id删除")
	@ApiOperation(value="维保历史表-通过id删除", notes="维保历史表-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_maintenance_history:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buMaintenanceHistoryService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "维保历史表-批量删除")
	@ApiOperation(value="维保历史表-批量删除", notes="维保历史表-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_maintenance_history:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buMaintenanceHistoryService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "维保历史表-通过id查询")
	@ApiOperation(value="维保历史表-通过id查询", notes="维保历史表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuMaintenanceHistory> queryById(@RequestParam(name="id",required=true) String id) {
		BuMaintenanceHistory buMaintenanceHistory = buMaintenanceHistoryService.getById(id);
		if(buMaintenanceHistory==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buMaintenanceHistory);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buMaintenanceHistory
    */
    //@RequiresPermissions("org.jeecg.modules:bu_maintenance_history:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuMaintenanceHistory buMaintenanceHistory) {
        return super.exportXls(request, buMaintenanceHistory, BuMaintenanceHistory.class, "维保历史表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_maintenance_history:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuMaintenanceHistory.class);
    }

}
